###############################################################################
# ImageShack.pl                                                               #
###############################################################################
# ImageShack Uploader                                                         #
# Adds an ImageShack Uploader to your Post page                               #
# Version:        2.0a (YaBB 2.0/2.1)                                         #
# Released:       January 28, 2006                                            #
# =========================================================================== #
# Written by Curtiss Grymala for the YaBB community                           #
###############################################################################
# ImageShack Admin Settings                                                   #
###############################################################################

LoadLanguage("ImageShack");
if (-e "$vardir/ImageShack.txt") { require "$vardir/ImageShack.txt"; }

sub ModifyImageShack {
	&is_admin_or_gmod;

$yymain .= qq~
<table>
  <tr valign="top">
    <td class="titlebg" align="left" colspan="3">
      <img src="$imagesdir/xx.gif" alt="$imageshack_txt{'3'}" border="0" />
      <b>$imageshack_txt{'3'}</b>
    </td>
  </tr>
  <tr valign="top">
    <td class="windowbg" align="left" colspan="3">
      $imageshack_txt{'4'}
    </td>
  </tr>
  <tr valign="top">
    <td class="windowbg2" align="left">
	<form action="$adminurl?action=imageshack2" method="post">
      $imageshack_txt{'5'}
    </td>
    <td class="windowbg3" align="left">
      <input type="text" name="issize" value="$issize" />
    </td>
    <td class="windowbg" align="center" rowspan="5" valign="middle">
      <img src="$modimgurl/ImageShack/imageshack.png" alt="" />
    </td>
  </tr>
  <tr valign="top">
    <td class="windowbg2" align="left">
      $imageshack_txt{'7'}
    </td>
    <td class="windowbg3" align="left">
      <input type="text" name="iswidth" value="$iswidth" />
    </td>
  </tr>
  <tr valign="top">
    <td class="windowbg2" align="left">
      $imageshack_txt{'8'}
    </td>
    <td class="windowbg3" align="left">
      <input type="text" name="isheight" value="$isheight" />
    </td>
  </tr>
  <tr valign="top">
    <td class="windowbg2" align="left">
      $imageshack_txt{'6'}
      <br /><span style="font-style:italic;font-size:10px;">($imageshack_txt{'6a'})
      <br />$imageshack_txt{'10'}</span>
    </td>
    <td class="windowbg3" align="left">
      <input type="text" name="istxtcolor" value="$istxtcolor" />
    </td>
  </tr>
  <tr valign="top">
    <td class="windowbg2" align="left">
      $imageshack_txt{'11'}
    </td>
    <td class="windowbg3" align="left">
      <input type="checkbox" name="is_on_off" value="1"~;
  if($is_on_off == 1) {
  	$yymain .= qq~ checked="checked"~;
  }
$yymain .= qq~ />
    </td>
  </tr>
  <tr>
    <td class="windowbg" colspan="2">
		<b>$imageshack_txt{'13'}</b>
    </td>
  </tr>~;

## Begin Code to load board list ##
	my (@masterdata, $category, @data, $found, $tmp, @memgroups, @newcatdata, $boardname);
	unless ($mloaded == 1) { require "$boardsdir/forum.master"; }
	foreach $catid (@categoryorder) {
		$boardlist = $cat{$catid};
		(@bdlist) = split(/\,/, $boardlist);
		($catname, $catperms) = split(/\|/, $catinfo{"$catid"});

		$cataccess = &CatAccess($catperms);
		if (!$cataccess) { next; }

		foreach $board (@bdlist) {
			($boardname, $boardperms, $boardview) = split(/\|/, $board{"$board"});
			&ToChars($boardname);
			my $access = &AccessCheck($board, '', $boardperms);
			if (!$iamadmin && $access ne "granted" && $boardview != 1) { next; }

		$yymain .= qq~
  <tr>
    <td class="windowbg2">
    	$boardname
    </td>
    <td class="windowbg3">
		<input type="checkbox" name="$board" value="1"~;
			if($isboard{$board} == 1 || $FORM{$board} == 1) {
				$yymain .= qq~ checked="checked"~;
			}
		$yymain .= qq~ />
    </td>
  </tr>~;
		}
	}
## End Code to load board list ##

## Begin Code to load template list and set text colors for each template ##
$is = 1;
$yymain .= qq~
  <tr>
    <td class="windowbg" colspan="2">
      <b>$imageshack_txt{'12'}</b>
      <br /><span style="font-style:italic;font-size:10px;">$imageshack_txt{'12a'}
      <br />$imageshack_txt{'10'}</span>
 	 </td>
  </tr>~;     

	&CheckNewTemplates;

	unless ($templatesloaded == 1) { require "$vardir/template.cfg"; }
	$drawndirs = "";
	while (($curtemplate, $value) = each(%templateset)) {
	$templatename = $curtemplate;
	$curtemplate =~ s/ /_/g;
if($imageshack_template{$curtemplate}) {
	$k = qq~ value="$imageshack_template{$curtemplate}"~;
}
elsif($FORM{$is}) {
	$k = qq~ value="$FORM{$is}"~;
}
else {
	$k = qq~~;
}
		$drawndirs .= qq~
  <tr>
    <td class="windowbg2">
      $templatename
    </td>
    <td class="windowbg3">
    	<input type="textbox" name="$is"$k />
    </td>
  </tr>~;
  	$is = $is + 1;
	}

	$yymain .= $drawndirs;

## End Code to load template list and set text colors for each template ##

## Begin Code to load synidcation images ##

$yymain .= qq~
<tr valign="top">
	<td class="windowbg" colspan="2">
		<b>$imageshack_txt{'14'}</b>
	</td>
</tr>~;

my @image_names = ('imageshack.png', 'iss1.png', 'iss2.png', 'iss3.png', 'iss4.png', 'is1.gif', 'is2.gif', 'is3.gif', 'is4.gif', 'is5.gif', 'is6.gif', 'is7.gif', 'is8.gif');
foreach $image (@image_names) {
	if($image eq $is_image) {
		$k = qq~ checked="checked"~;
	}
	else {
		$k = qq~~;
	}
	$yymain .= qq~
<tr valign="top">
	<td class="windowbg2" colspan="2">
				<input type="radio" name="is_image" value="$image"$k />&nbsp;&nbsp;<img src="$modimgurl/ImageShack/$image" alt="" />
	</td>
</tr>~;
}

## End Code to load synidcation images ##

$yymain .= qq~
  <tr valign="top">
    <td class="windowbg" align="right" colspan="2">
      <input type="submit" value="$imageshack_txt{'9'}" name="ImageShackSubmit" />
      </form>
    </td>
  </tr>
</table>
~;

	$yytitle = "$imageshack_txt{'3'}";
	$action_area = "imageshack";
	&AdminTemplate;
	exit;
}

sub ModifyImageShack2 {
	&is_admin_or_gmod;
	$FORM{'issize'} =~ tr/\r//d;
	$FORM{'issize'} =~ s~\A\n~~;
	$FORM{'issize'} =~ s~\n\Z~~;
	$FORM{'issize'} =~ s/[^0-9^_]//g;
#	$FORM{'istxtcolor'} =~ tr/\r//d;
#	$FORM{'istxtcolor'} =~ s~\A\n~~;
#	$FORM{'istxtcolor'} =~ s~\n\Z~~;
#	$FORM{'istxtcolor'} =~ s/[^0-9^_]//g;
	$FORM{'iswidth'} =~ tr/\r//d;
	$FORM{'iswidth'} =~ s~\A\n~~;
	$FORM{'iswidth'} =~ s~\n\Z~~;
	$FORM{'iswidth'} =~ s/[^0-9^_]//g;
	$FORM{'isheight'} =~ tr/\r//d;
	$FORM{'isheight'} =~ s~\A\n~~;
	$FORM{'isheight'} =~ s~\n\Z~~;
	$FORM{'isheight'} =~ s/[^0-9^_]//g;

## Generate the variable file ##
my @var_names = ('issize', 'istxtcolor', 'iswidth', 'isheight', 'is_on_off', 'is_image');
my @var_comments = (" # Size of the ImageShack input textbox", " # Default color of the text within the ImageShack iFrame", " # Width of the ImageShack iFrame", " # Height of the ImageShack iFrame", " # If this is 1, it will disable the ImageShack iFrame altogether", " # Syndication image selection");

		$output = qq~###############################################################################
# ImageShack.txt                                                              #
###############################################################################
# ImageShack Uploader                                                         #
# Variable Values For ImageShack                                              #
# Version:        2.0a (YaBB 2.0/2.1)                                         #
# Released:       January 23, 2006                                            #
# =========================================================================== #
# Written by Curtiss Grymala for the YaBB community                           #
###############################################################################
# ImageShack Uploader Variable Definitions                                    #
###############################################################################

~;

$i = 0;
while ($i <= 5) {
$output .= qq~\$@var_names[$i] = \'$FORM{@var_names[$i]}\';@var_comments[$i]
~;
$i = $i + 1;
}

## Begin code to save individual board variables ##
	my (@masterdata, $category, @data, $found, $tmp, @memgroups, @newcatdata, $boardname);
	unless ($mloaded == 1) { require "$boardsdir/forum.master"; }
	foreach $catid (@categoryorder) {
		$boardlist = $cat{$catid};
		(@bdlist) = split(/\,/, $boardlist);
		($catname, $catperms) = split(/\|/, $catinfo{"$catid"});

		$cataccess = &CatAccess($catperms);
		if (!$cataccess) { next; }

		foreach $board (@bdlist) {
			($boardname, $boardperms, $boardview) = split(/\|/, $board{"$board"});
			&ToChars($boardname);
			my $access = &AccessCheck($board, '', $boardperms);
			if (!$iamadmin && $access ne "granted" && $boardview != 1) { next; }
		$output .= qq~\$isboard{$board} = \'$FORM{$board}\'; # Enable ImageShack on $boardname
~;
		}
	}
## End code to save individual board variables ##

## Begin code to save individual color selections for each template ##

	$is = 1;
	&CheckNewTemplates;

	unless ($templatesloaded == 1) { require "$vardir/template.cfg"; }
	while (($curtemplate, $value) = each(%templateset)) {
#		$FORM{$is} =~ tr/\r//d;
#		$FORM{$is} =~ s~\A\n~~;
#		$FORM{$is} =~ s~\n\Z~~;
#		$FORM{$is} =~ s/[^0-9^_]//g;
		$curtemplate =~ s/ /_/g;
		$output .= qq~\$imageshack_template{$curtemplate} = \'$FORM{$is}\'; # Hex color setting for $curtemplate
~;
		$is = $is + 1;
	}

## End code to save individual color selections for each template ##

$output .= q~
1;~;

fopen(IMAGESHACKSETTINGS, ">$vardir/ImageShack.txt");
	print IMAGESHACKSETTINGS $output;
	fclose(IMAGESHACKSETTINGS); 
 	$yySetLocation = qq~$adminurl?action=imageshack~;
	&redirectexit;
}